package thesis.main;

import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Set;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.fs.FileSystem;
import org.apache.hadoop.fs.Path;
import org.apache.hadoop.io.SequenceFile;
import org.apache.hadoop.io.Writable;
import org.apache.hadoop.io.WritableComparable;

import org.apache.mahout.clustering.kmeans.KMeansDriver;
import org.apache.mahout.clustering.kmeans.RandomSeedGenerator;



import thesis.similarity.WeightedDistanceMeasure;
import thesis.vector.combination.VectorCombination;

public class Experiment_01 {

	/**
	 * @param args
	 * @throws InstantiationException 
	 * @throws IllegalAccessException 
	 * @throws IOException 
	 * @throws ClassNotFoundException 
	 */
	public static void main(String[] args) throws IOException, IllegalAccessException, InstantiationException, ClassNotFoundException {
		// TODO Auto-generated method stub
		String root = "C:\\Users\\HE GAOJIE\\Desktop\\test2";
		String term_vector_seq = root + "\\term_vector_seq";
		String inlink_vector_seq = root + "\\inlink_vector_seq";
		String outlink_vector_seq = root + "\\outlink_vector_seq";
		String pagerankFile = root + "\\page_rank";
		String centroidsSeqFile = root + "\\centroids";
		String result = root + "\\result";
		String tiop1_vector_seq = root + "\\tiop_vector_seq";
		String tiop11_vector_seq = root + "\\tiop11_vector_seq";
		
		String inputSeq1 = term_vector_seq + "\\sequence_file.seq";
		String inputSeq2 = inlink_vector_seq + "\\sequence_file.seq";
		String inputSeq3 = outlink_vector_seq + "\\sequence_file.seq";
		String prFile = pagerankFile + "\\pagerank.ser";
		
		String outputSeq = tiop1_vector_seq + "\\sequence_file.seq";
		String outputSeq1 = tiop11_vector_seq + "\\sequence_file.seq";

		// create vector
		//VectorCombination.combine3vectors1pr(inputSeq1, inputSeq2, inputSeq3, prFile, outputSeq, true);
		//VectorCombination.combine3vectors1pr(inputSeq1, inputSeq2, inputSeq3, prFile, outputSeq1, false);
		
		// initial centroids
		int k = 15;
		//String clusters = RandomSeedGenerator.buildRandom(tiop1_vector_seq, centroidsSeqFile, k).toString();
		String clusters = centroidsSeqFile;
		// Kmeans clustering
		//KMeansDriver.runJob(tiop1_vector_seq, clusters, result, WeightedDistanceMeasure.class.getName(), 0.001, 20, 1);
		KMeansDriver.runJob(tiop11_vector_seq, clusters, result, WeightedDistanceMeasure.class.getName(), 0.001, 20, 1);
		// Display the result
		System.out.println("KMeans clustering Done!");
		System.out.println("================== Final result ==================");
		Configuration conf1 = new Configuration();
		FileSystem fs1 = FileSystem.get(conf1);
		SequenceFile.Reader reader1 = new SequenceFile.Reader(fs1, new Path(result + "\\points\\part-00000"), conf1);
		WritableComparable key1 = (WritableComparable) reader1.getKeyClass().newInstance();
		Writable value1 = (Writable) reader1.getValueClass().newInstance();
		HashMap<Integer, ArrayList<String>> map = new HashMap<Integer, ArrayList<String>>();
		while (reader1.next(key1, value1))
		{
			if (!map.containsKey(new Integer(value1.toString())))
			{
				ArrayList<String> list = new ArrayList<String>();
				list.add(key1.toString());
				map.put(new Integer(value1.toString()), list);
			}
			else
			{
				ArrayList<String> list = map.get(new Integer(value1.toString()));
				list.add(key1.toString());
				map.put(new Integer(value1.toString()), list);
			}
		}
		
		// write to output
		Writer writer2 = new FileWriter(result + "\\KMeansResult.txt");
		Set<Integer> keyset = map.keySet();
		Iterator<Integer> iterator = keyset.iterator();
		int count = 0;
		while (iterator.hasNext())
		{
			count++;
			Integer c = iterator.next();
			String cluster = "C" + c.toString();	
			ArrayList<String> list = map.get(c);
			writer2.write(cluster + " {" + list.size() + "} : " + "[");
			for (int i = 0; i < list.size(); i++)
			{
				writer2.write(list.get(i) + ", ");
			}
			writer2.write("]");
			writer2.write("\n");
		}
		System.out.println("Total clusters = " + count);
		writer2.write("\n");
		writer2.write("Total clusters = " + count);
		writer2.flush();
		writer2.close();

	}

}
