package thesis.main;

import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Set;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.fs.FileSystem;
import org.apache.hadoop.fs.Path;
import org.apache.hadoop.io.SequenceFile;
import org.apache.hadoop.io.Writable;
import org.apache.hadoop.io.WritableComparable;
import org.apache.mahout.clustering.canopy.CanopyDriver;
import org.apache.mahout.clustering.kmeans.KMeansDriver;
import org.apache.mahout.clustering.kmeans.RandomSeedGenerator;



import thesis.similarity.WeightedDistanceMeasure;
import thesis.vector.combination.VectorCombination;

public class Experiment_02 {

	/**
	 * @param args
	 * @throws ClassNotFoundException 
	 * @throws IOException 
	 * @throws IllegalAccessException 
	 * @throws InstantiationException 
	 */
	public static void main(String[] args) throws IOException, ClassNotFoundException, InstantiationException, IllegalAccessException {
		// TODO Auto-generated method stub
		String root = "C:\\Users\\HE GAOJIE\\Desktop\\test1";
		String htmlSeqFile = root + "\\html_vector";
		String inlinkSeqFile = root + "\\inlink_vector";
		String outlinkSeqFile = root + "\\outlink_vector";
		String pagerankFile = root + "\\page_rank";
		String newSeqFile = root + "\\newVector";
		String centroidsSeqFile = root + "\\centroids";
		String result = root + "\\result";
		
		String seq = "\\sequence_file.seq";
		String pr = "\\pagerank.ser";
		String newseq = "\\new.seq";
		String inputSeq1 = htmlSeqFile + seq;
		String inputSeq2 = inlinkSeqFile + seq;
		String inputSeq3 = outlinkSeqFile + seq;
		String prFile = pagerankFile + pr;
		String outputSeq = newSeqFile + newseq;
			
//		double t1 = 0.7895;
//		double t2 = 0.785;
		
		// Create new vector
		VectorCombination.combine3vectors1pr(inputSeq1, inputSeq2, inputSeq3, prFile, outputSeq, true);
		// Canopy clustering
		int k = 14;
        String clusters = RandomSeedGenerator.buildRandom(newSeqFile, centroidsSeqFile, k).toString();
        //String clusters = centroidsSeqFile;
//		CanopyDriver.runJob(newSeqFile, clusters, WeightedDistanceMeasure.class.getName(), t1, t2);
//		// Display canopy clustering result
//		Configuration conf = new Configuration();
//		FileSystem fs = FileSystem.get(conf);
//		SequenceFile.Reader reader = new SequenceFile.Reader(fs, new Path(centroidsSeqFile + "\\part-00000"), conf);
//		WritableComparable key = (WritableComparable) reader.getKeyClass().newInstance();
//		Writable value = (Writable) reader.getValueClass().newInstance();
//		int c = 0;
//		while (reader.next(key, value))
//		{
//			c++;
//		}
//		System.out.println("The K number of clusters = " + c);
//		reader.close();
		// KMeans clustering
        KMeansDriver.runJob(newSeqFile, clusters, result, WeightedDistanceMeasure.class.getName(), 0.001, 20, 1);
		
        System.out.println("KMeans clustering Done!");
		
		// Display the result
		System.out.println("================== Final result ==================");
		Configuration conf1 = new Configuration();
		FileSystem fs1 = FileSystem.get(conf1);
		SequenceFile.Reader reader1 = new SequenceFile.Reader(fs1, new Path(result + "\\points\\part-00000"), conf1);
		WritableComparable key1 = (WritableComparable) reader1.getKeyClass().newInstance();
		Writable value1 = (Writable) reader1.getValueClass().newInstance();
		HashMap<Integer, ArrayList<String>> map = new HashMap<Integer, ArrayList<String>>();
		while (reader1.next(key1, value1))
		{
			if (!map.containsKey(new Integer(value1.toString())))
			{
				ArrayList<String> list = new ArrayList<String>();
				list.add(key1.toString());
				map.put(new Integer(value1.toString()), list);
			}
			else
			{
				ArrayList<String> list = map.get(new Integer(value1.toString()));
				list.add(key1.toString());
				map.put(new Integer(value1.toString()), list);
			}
		}
		
		//map.
		Writer writer2 = new FileWriter(result + "\\KMeansResult.txt");
		Set<Integer> keyset = map.keySet();
		Iterator<Integer> iterator = keyset.iterator();
		int count = 0;
		while (iterator.hasNext())
		{
			count++;
			Integer c = iterator.next();
			String cluster = "C" + c.toString();	
			ArrayList<String> list = map.get(c);
			//System.out.print(cluster + " {" + list.size() + "} : " + "[");
			writer2.write(cluster + " {" + list.size() + "} : " + "[");
			for (int i = 0; i < list.size(); i++)
			{
				//System.out.print(list.get(i) + ", ");
				writer2.write(list.get(i) + ", ");
			}
			//System.out.println("]");
			writer2.write("]");
			writer2.write("\n");
		}
		System.out.println("Total clusters = " + count);
		writer2.write("\n");
		writer2.write("Total clusters = " + count);
		writer2.flush();
		writer2.close();
		
	}

}
