package thesis.main;

import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Set;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.fs.FileSystem;
import org.apache.hadoop.fs.Path;
import org.apache.hadoop.io.SequenceFile;
import org.apache.hadoop.io.Writable;
import org.apache.hadoop.io.WritableComparable;
import org.apache.hadoop.mapred.JobConf;
import org.apache.hadoop.mapred.jobcontrol.Job;
import org.apache.mahout.clustering.canopy.CanopyDriver;
import org.apache.mahout.clustering.kmeans.KMeansDriver;
import org.apache.mahout.clustering.kmeans.RandomSeedGenerator;
import org.apache.mahout.common.distance.CosineDistanceMeasure;
import org.apache.mahout.math.Vector;
import org.apache.mahout.utils.vectors.SequenceFileVectorIterable;
import org.apache.mahout.utils.vectors.SequenceFileVectorIterable.SeqFileIterator;

import thesis.vector.combination.VectorCombination;

public class Experiment_03 {

	/**
	 * @param args
	 * @throws IOException 
	 * @throws ClassNotFoundException 
	 * @throws IllegalAccessException 
	 * @throws InstantiationException 
	 */
	public static void main(String[] args) throws IOException, ClassNotFoundException, InstantiationException, IllegalAccessException {

// TP1
		String root = "C:\\Users\\HE GAOJIE\\Desktop\\test";
		String html_vector = root + "\\html_vector";
		String new_vector = root + "\\new_vector";
		String centroids = root + "\\centroids";
		String result = root + "\\result";
		String page_rank = root + "\\page_rank";
		String seq = "\\sequence_file.seq";
		String pr = "\\pagerank.ser";
		//String newseq = "\\sequence_file.seq";
		
		//double t1 = 0.9;
		//double t2 = 0.78;
		
		String inputseq1 = html_vector + seq;
		String pr1 = page_rank + pr;
		String outputseq1 = new_vector + seq;
		
		// Create new vector sequence file
		VectorCombination.combine1vector1pr(inputseq1, pr1, outputseq1, true);
		//VectorCombination.combine1vector1pr(inputseq1, pr1, outputseq1, false);
		
		// initial centroids
		int k = 12;
		String clusters = RandomSeedGenerator.buildRandom(new_vector, centroids, k).toString();
		//String clusters = centroids;
		// Kmeans clustering
		KMeansDriver.runJob(new_vector, clusters, result, CosineDistanceMeasure.class.getName(), 0.001, 20, 1);
		//KMeansDriver.runJob(newVectorFile, centroidsSeqFile, output, CosineDistanceMeasure.class.getName(), 0.001, 20, 1);
		System.out.println("KMeans clustering Done!");
		
		// Display the result
		System.out.println("================== Final result ==================");
		Configuration conf1 = new Configuration();
		FileSystem fs1 = FileSystem.get(conf1);
		SequenceFile.Reader reader1 = new SequenceFile.Reader(fs1, new Path(result + "\\points\\part-00000"), conf1);
		WritableComparable key1 = (WritableComparable) reader1.getKeyClass().newInstance();
		Writable value1 = (Writable) reader1.getValueClass().newInstance();
		HashMap<Integer, ArrayList<String>> map = new HashMap<Integer, ArrayList<String>>();
		while (reader1.next(key1, value1))
		{
			if (!map.containsKey(new Integer(value1.toString())))
			{
				ArrayList<String> list = new ArrayList<String>();
				list.add(key1.toString());
				map.put(new Integer(value1.toString()), list);
			}
			else
			{
				ArrayList<String> list = map.get(new Integer(value1.toString()));
				list.add(key1.toString());
				map.put(new Integer(value1.toString()), list);
			}
		}
		
		//map.
		Writer writer2 = new FileWriter(result + "\\KMeansResult.txt");
		Set<Integer> keyset = map.keySet();
		Iterator<Integer> iterator = keyset.iterator();
		int count = 0;
		while (iterator.hasNext())
		{
			count++;
			Integer c = iterator.next();
			String cluster = "C" + c.toString();	
			ArrayList<String> list = map.get(c);
			System.out.print(cluster + " {" + list.size() + "} : " + "[");
			writer2.write(cluster + " {" + list.size() + "} : " + "[");
			for (int i = 0; i < list.size(); i++)
			{
				System.out.print(list.get(i) + ", ");
				writer2.write(list.get(i) + ", ");
			}
			System.out.println("]");
			writer2.write("]");
			writer2.write("\n");
		}
		System.out.println("Total clusters = " + count);
		writer2.write("\n");
		writer2.write("Total clusters = " + count);
		writer2.flush();
		writer2.close();
		
		
		
	}

}
