package thesis.main;


import java.io.IOException;
import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.fs.FileSystem;
import org.apache.hadoop.fs.Path;
import org.apache.hadoop.io.LongWritable;
import org.apache.hadoop.io.SequenceFile;
import org.apache.hadoop.mapred.JobConf;
import org.apache.hadoop.mapred.jobcontrol.Job;
import org.apache.mahout.math.RandomAccessSparseVector;
import org.apache.mahout.math.Vector;
import org.apache.mahout.math.VectorWritable;
import org.apache.mahout.utils.vectors.SequenceFileVectorIterable;
import org.apache.mahout.utils.vectors.SequenceFileVectorIterable.SeqFileIterator;

public class Test_CreateNewSeqFile {

	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException {
		// TODO Auto-generated method stub
		String htmlDir = "D:\\12_Master_thesis\\04_Experiment\\2010_5_28_food_200_100\\htmlSeq\\out.seq";
		String outDir = "D:\\12_Master_thesis\\04_Experiment\\2010_5_28_food_200_100\\outlinkSeq\\out.seq";
		String h_oDir = "D:\\12_Master_thesis\\04_Experiment\\2010_5_28_food_200_100\\h_oSeq\\out.seq";
		merge(htmlDir, outDir, h_oDir);
	}
	
	public static void merge(String SrcSeq1, String SrcSeq2, String TagSeq) throws IOException
	{
		// SequenceFile reader
		Path path1 = new Path(SrcSeq1);
		JobConf conf1 = new JobConf(Job.class);
		FileSystem fs1 = FileSystem.get(path1.toUri(), conf1);
		SequenceFile.Reader reader1 = new SequenceFile.Reader(fs1, path1, conf1);
		
		Path path2 = new Path(SrcSeq2);
		JobConf conf2 = new JobConf(Job.class);
		FileSystem fs2 = FileSystem.get(path2.toUri(), conf2);
		SequenceFile.Reader reader2 = new SequenceFile.Reader(fs2, path2, conf2);
		
        SequenceFileVectorIterable vectorIterable1 = new SequenceFileVectorIterable(reader1, false);
        SequenceFileVectorIterable vectorIterable2 = new SequenceFileVectorIterable(reader2, false);
        
        //Writer writer = new OutputStreamWriter(System.out);
        //Writer writer = new FileWriter("D:\\log.txt");
		
        SeqFileIterator iterator1 = (SeqFileIterator) vectorIterable1.iterator();
        SeqFileIterator iterator2 = (SeqFileIterator) vectorIterable2.iterator();
        
        // SequenceFile writer
        //VectorWriter vectorWriter = getSeqFileWriter(TagSeq);
        //long numDocs = vectorWriter.write(iterable, maxDocs);
        SequenceFile.Writer writer = getSeqFileWriter(TagSeq);
        
        long i = 0;
        while (iterator1.hasNext() && iterator2.hasNext())
        {
        	Vector vector1 = iterator1.next();
        	System.err.println("[SequenceFile 1] " + vector1.getName());
        	System.err.println("Vector " + i + " [Size] " + vector1.size());
        	Vector vector2 = iterator2.next();
        	System.err.println("[SequenceFile 2] " + vector2.getName());
        	System.err.println("Vector " + i + " [Size] " + vector2.size());
        	
        	// new vector
        	int cardinality = vector1.size() + vector2.size();
        	RandomAccessSparseVector newVector = new RandomAccessSparseVector(cardinality);
        	//RandomAccessSparseVector newVector = new RandomAccessSparseVector();
        	
        	int index = 0;
        	for (int a = 0; a < vector1.size(); a++)
        	{
        		if (vector1.getQuick(a) != 0.0)
        		{
        			newVector.setQuick(index, vector1.getQuick(a));
        		}
        		index++;
        	}
        	for (int b = 0; b < vector2.size(); b++)
        	{
        		if (vector2.getQuick(b) != 0.0)
        		{
        			newVector.setQuick(index, vector2.getQuick(b));
        		}
        		index++;
        	}
        	//vector1.addTo(vector2);
        	System.err.println("Vector after merging " + i + " [Size] " + newVector.size());
        	
        	
        	writer.append(new LongWritable(i), new VectorWritable(newVector));
        	i++;
        }
        
        writer.close();
        System.err.println("Dumped " + i + " Vectors");
	}
	
	private static SequenceFile.Writer getSeqFileWriter(String outFile) throws IOException 
	{
		Path path = new Path(outFile);
		Configuration conf = new Configuration();
		FileSystem fs = FileSystem.get(conf);
		// TODO: Make this parameter driven
		SequenceFile.Writer seqWriter = SequenceFile.createWriter(fs, conf, path, LongWritable.class, VectorWritable.class);
		return seqWriter;
		//return new SequenceFileVectorWriter(seqWriter);
	}
	
}
