package thesis.main;

import java.io.IOException;
import java.net.UnknownHostException;
import java.util.ArrayList;
import java.util.HashMap;

import org.htmlcleaner.XPatherException;

import thesis.crawler.GoogleCrawler;
import thesis.crawler.YahooCrawler;

public class Test_ExtractInLinksFromURL {

	/**
	 * @param args
	 * @throws InterruptedException 
	 * @throws XPatherException 
	 * @throws IOException 
	 * @throws UnknownHostException 
	 */
	public static void main(String[] args) throws UnknownHostException, IOException, XPatherException, InterruptedException {

// TEST 1
		//==================================
		String query = "food";
		String inlinkDir = "D:\\12_Master_thesis\\04_Experiment\\Data_Query(food)_Search(200)_Inlink(100)_Date(2010-5-28)\\yahoo_inlink";
		int resultSize = 200;
		int inlinkNum = 100;
		//===================================
		
		ArrayList<String> urlList = GoogleCrawler.getInstance().getResultURLs(query, resultSize);
		Thread.sleep(5000);
		
		for (int i = 0; i < urlList.size(); i++)
		{
			System.out.println("[INFO] " + i + " " + urlList.get(i));
			try
			{
				HashMap<String, Integer> map = YahooCrawler.getInstance().getInlinkDomains(urlList.get(i), inlinkNum);
				int indegree = Test_DownloadSearchResults.writeInLinkFile(map, inlinkDir, null, i);
				System.out.println("    Create in-links file...[OK], indegree = " + indegree);
				//Thread.sleep(5000);
			}
			catch (Exception e)
			{
				System.out.println("    Create in-links file...[FAILURE]");
				continue;
			}
		}
		
// TEST 2
		//singleTask("www.foodnetwork.com", 0, 100, inlinkDir);
	}
	
	public static void singleTask(String url, int id, int inlinkNum, String inlinkDir)
	{
		System.out.println("[INFO] " + id + " " + url);
		try
		{
			HashMap<String, Integer> map = GoogleCrawler.getInstance().getInlinkDomains(url, inlinkNum);
			int indegree = Test_DownloadSearchResults.writeInLinkFile(map, inlinkDir, null, id);
			System.out.println("    Create in-links file...[OK], indegree = " + indegree);
		}
		catch (Exception e)
		{
			
			System.out.println("    Create in-links file...[FAILURE]");
			System.out.println(e.toString());
			e.printStackTrace(System.out);
		}
	}
	

}
