package thesis.main;

import java.io.BufferedInputStream;
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Set;
import java.util.Map.Entry;

import org.htmlcleaner.XPatherException;

import thesis.crawler.HtmlParser;

public class Test_ExtractOutlinkForSingleUrl {

	/**
	 * @param args
	 * @throws XPatherException 
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException, XPatherException {
		// TODO Auto-generated method stub
		//+++++++++++++++++++++++++++++++++++++++++++
		String url = "http://www.bluesmokesalsa.com/";
		int id = 157;
		//+++++++++++++++++++++++++++++++++++++++++++
		String root = "D:\\12_Master_thesis\\04_Experiment\\";
		String folder = "6_4_salsa_200_100";
		String outlinkDir = root + folder + "\\outlink_files";
		String fileName = root + folder + "\\html_files\\" + id + ".htm";
		
		File html = new File(fileName);
	    FileInputStream fis = null;
	    BufferedInputStream bis = null;
	    DataInputStream dis = null;

	    fis = new FileInputStream(html);
	    // Here BufferedInputStream is added for fast reading.
	    bis = new BufferedInputStream(fis);
	    dis = new DataInputStream(bis);

	    StringBuilder sb = new StringBuilder();
	    // dis.available() returns 0 if the file does not have more lines.
	    while (dis.available() != 0) {
	    	// this statement reads the line from the file and print it to
	    	// the console.
	    	//System.out.println(dis.readLine());
	    	sb.append(dis.readLine());
	    }
	    // dispose all the resources after using them.
	    fis.close();
	    bis.close();
	    dis.close();
		
		HashMap<String, Integer> map = HtmlParser.getInstance().getOutlinkDomains(url, sb.toString());
		
		int outdegree = writeToFile(map, outlinkDir, url, id);
		System.out.println("Successful, outdegree = " + outdegree);
		
	}

	private static int writeToFile(HashMap<String, Integer> map, String dir, String url, int id) throws IOException
	{
		File directory = new File(dir);
		if (directory.isDirectory() && !directory.exists())
			directory.mkdir();
		
		String fileName = dir + "\\" + id + ".txt";
		FileWriter fwriter = new FileWriter(fileName);
		BufferedWriter bwriter = new BufferedWriter(fwriter);
		
		Set<Entry<String, Integer>> set = map.entrySet();
		Iterator<Entry<String, Integer>> it = set.iterator();
		
		int total = 0;
		while (it.hasNext())
		{
			Entry<String, Integer> me = it.next();
			for (int i = 0; i < me.getValue(); i++)
			{
				total++;
				bwriter.write(me.getKey());
				//bwriter.write(" ");
				bwriter.newLine();
				//bwriter.write("\n");
			}
		}
		
		bwriter.close();
		fwriter.close();
		return total;
	}
}
