package thesis.main;



import java.io.BufferedWriter;
import java.io.File;
import java.io.FileOutputStream;

import java.io.IOException;
import java.io.OutputStreamWriter;
import java.nio.charset.Charset;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.fs.FileSystem;
import org.apache.hadoop.fs.Path;
import org.apache.hadoop.io.LongWritable;
import org.apache.hadoop.io.SequenceFile;
import org.apache.lucene.index.IndexReader;
import org.apache.lucene.store.Directory;
import org.apache.lucene.store.FSDirectory;
import org.apache.mahout.utils.vectors.TFIDF;
import org.apache.mahout.utils.vectors.TermInfo;
import org.apache.mahout.utils.vectors.Weight;
import org.apache.mahout.utils.vectors.io.JWriterTermInfoWriter;

import org.apache.mahout.utils.vectors.io.SequenceFileVectorWriter;
import org.apache.mahout.utils.vectors.io.VectorWriter;
import org.apache.mahout.utils.vectors.lucene.CachedTermInfo;
import org.apache.mahout.utils.vectors.lucene.LuceneIterable;
import org.apache.mahout.utils.vectors.lucene.TFDFMapper;
import org.apache.mahout.utils.vectors.lucene.VectorMapper;
import org.apache.mahout.math.*;

public class Test_IndexToSequenceFile {

	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException {
		// TODO Auto-generated method stub
		String root = "D:\\12_Master_thesis\\04_Experiment";
		String query = "black_bear_attack";
// 1. ====================== for term ==========================
		System.out.println("Start to generate sequence file for html pages!");
		long maxDocs1 = Long.MAX_VALUE;
		String indexPath1 = root + "\\" + "6_4_" + query + "_200_100\\html_index";
		String seqFile1 = root + "\\" + "6_4_" + query + "_200_100\\html_seq\\sequence_file.seq";
		String dicFile1 = root + "\\" + "6_4_" + query + "_200_100\\html_seq\\dict.txt";
		File file1 = new File(indexPath1);
		Directory dir1 = FSDirectory.open(file1);
		IndexReader indexReader1 = IndexReader.open(dir1, true);
		Weight weight1 = new TFIDF();
		
		// Filter purpose
		int minDf1 = 3;
		int maxDFPercent1 = 99;
		
		String field1 = "content";
		TermInfo termInfo1 = new CachedTermInfo(indexReader1, field1, minDf1, maxDFPercent1);
		VectorMapper mapper1 = new TFDFMapper(indexReader1, weight1, termInfo1);
		double norm1 = 2.0;
		String idField1 = null;
		LuceneIterable iterable1 = new LuceneIterable(indexReader1, idField1, field1, mapper1, norm1);
		VectorWriter vectorWriter1 = getSeqFileWriter(seqFile1);
        long numDocs1 = vectorWriter1.write(iterable1, maxDocs1);
        vectorWriter1.close();

        String delimiter1 = "\t";
        File dictOutFile1 = new File(dicFile1);
        BufferedWriter writer1 = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(dictOutFile1), Charset.forName("UTF8")));
        JWriterTermInfoWriter tiWriter1 = new JWriterTermInfoWriter(writer1, delimiter1, field1);
        tiWriter1.write(termInfo1);
        tiWriter1.close();
        writer1.close();
        System.out.println("Wrote: " + numDocs1 + " vectors.");
        System.out.println();
        
// 2. ====================== for in-links ==========================
        long maxDocs2 = Long.MAX_VALUE;
        System.out.println("Start to generate sequence file for in-links!");
		String indexPath2 = root + "\\" + "6_4_" + query + "_200_100\\inlink_index";
		String seqFile2 = root + "\\" + "6_4_" + query + "_200_100\\inlink_seq\\sequence_file.seq";
		String dicFile2 = root + "\\" + "6_4_" + query + "_200_100\\inlink_seq\\dict.txt";
		File file2 = new File(indexPath2);
		Directory dir2 = FSDirectory.open(file2);
		IndexReader indexReader2 = IndexReader.open(dir2, true);
		Weight weight2 = new TFIDF();
		
		// Filter purpose
		int minDf2 = 2;
		int maxDFPercent2 = 99;
		
		String field2 = "links";
		TermInfo termInfo2 = new CachedTermInfo(indexReader2, field2, minDf2, maxDFPercent2);
		VectorMapper mapper2 = new TFDFMapper(indexReader2, weight2, termInfo2);
		double norm2 = 2.0;
		String idField2 = null;
		LuceneIterable iterable2 = new LuceneIterable(indexReader2, idField2, field2, mapper2, norm2);
		VectorWriter vectorWriter2 = getSeqFileWriter(seqFile2);
        long numDocs2 = vectorWriter2.write(iterable2, maxDocs2);
        vectorWriter2.close();

        String delimiter2 = "\t";
        File dictOutFile2 = new File(dicFile2);
        BufferedWriter writer2 = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(dictOutFile2), Charset.forName("UTF8")));
        JWriterTermInfoWriter tiWriter2 = new JWriterTermInfoWriter(writer2, delimiter2, field2);
        tiWriter2.write(termInfo2);
        tiWriter2.close();
        writer2.close();
        System.out.println("Wrote: " + numDocs2 + " vectors.");
        System.out.println();
        
// 2. ====================== for out-links ==========================        
        System.out.println("Start to generate sequence file for out-links!");
        long maxDocs3 = Long.MAX_VALUE;
		String indexPath3 = root + "\\" + "6_4_" + query + "_200_100\\outlink_index";
		String seqFile3 = root + "\\" + "6_4_" + query + "_200_100\\outlink_seq\\sequence_file.seq";
		String dicFile3 = root + "\\" + "6_4_" + query + "_200_100\\outlink_seq\\dict.txt";
		File file3 = new File(indexPath3);
		Directory dir3 = FSDirectory.open(file3);
		IndexReader indexReader3 = IndexReader.open(dir3, true);
		Weight weight3 = new TFIDF();
		
		// Filter purpose
		int minDf3 = 1;
		int maxDFPercent3 = 99;
		
		String field3 = "links";
		TermInfo termInfo3 = new CachedTermInfo(indexReader3, field3, minDf3, maxDFPercent3);
		VectorMapper mapper3 = new TFDFMapper(indexReader3, weight3, termInfo3);
		double norm3 = 2.0;
		String idField3 = null;
		LuceneIterable iterable3 = new LuceneIterable(indexReader3, idField3, field3, mapper3, norm3);
		VectorWriter vectorWriter3 = getSeqFileWriter(seqFile3);
        long numDocs3 = vectorWriter3.write(iterable3, maxDocs3);
        vectorWriter3.close();

        String delimiter3 = "\t";
        File dictOutFile3 = new File(dicFile3);
        BufferedWriter writer3 = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(dictOutFile3), Charset.forName("UTF8")));
        JWriterTermInfoWriter tiWriter3 = new JWriterTermInfoWriter(writer3, delimiter3, field3);
        tiWriter3.write(termInfo3);
        tiWriter3.close();
        writer3.close();
        System.out.println("Wrote: " + numDocs3 + " vectors.");
        
	}
	
	  private static VectorWriter getSeqFileWriter(String outFile) throws IOException {
		    Path path = new Path(outFile);
		    Configuration conf = new Configuration();
		    FileSystem fs = FileSystem.get(conf);
		    // TODO: Make this parameter driven
		    SequenceFile.Writer seqWriter = SequenceFile.createWriter(fs, conf, path, LongWritable.class, VectorWritable.class);
		    
		    return new SequenceFileVectorWriter(seqWriter);
		  }

}



