package thesis.main;

import java.io.IOException;
import java.net.UnknownHostException;


import org.htmlcleaner.XPatherException;


import thesis.indexing.HtmlIndexer;
import thesis.indexing.TxtIndexer;

public class Test_IndexingSearchResults {

	/**
	 * @param args
	 * @throws InterruptedException 
	 * @throws XPatherException 
	 * @throws IOException 
	 * @throws UnknownHostException 
	 */
	public static void main(String[] args) throws UnknownHostException, IOException, XPatherException, InterruptedException {
		String root = "D:\\12_Master_thesis\\04_Experiment";
		String query = "big_apple";
		
		String inlinkDataDir = root + "\\" + "6_4_" + query + "_200_100\\inlink_files";
		String outlinkDataDir = root + "\\" + "6_4_" + query + "_200_100\\outlink_files";
		String pageDataDir = root + "\\" + "6_4_" + query + "_200_100\\html_files";
		
		String inlinkIndexDir = root + "\\" + "6_4_" + query + "_200_100\\inlink_index";;
		String outlinkIndexDir = root + "\\" + "6_4_" + query + "_200_100\\outlink_index";
		String pageIndexDir = root + "\\" + "6_4_" + query + "_200_100\\html_index";
		
		TxtIndexer inIndexer = new TxtIndexer(inlinkIndexDir);
		TxtIndexer outIndexer = new TxtIndexer(outlinkIndexDir);
		HtmlIndexer pageIndexer = new HtmlIndexer(pageIndexDir);

		System.out.println("Start to index html pages...");
		pageIndexer.index(pageDataDir);
		System.out.println("Completed!");
		System.out.println();
		System.out.println("Start to index out-links...");
		outIndexer.index(outlinkDataDir);
		System.out.println("Completed!");
		System.out.println();
		System.out.println("Start to index in-links...");
		inIndexer.index(inlinkDataDir);
		System.out.println("Completed!");
		System.out.println();
		
		pageIndexer.close();
		outIndexer.close();
		inIndexer.close();		
	}

}
