package thesis.main;

import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Set;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.fs.FileSystem;
import org.apache.hadoop.fs.Path;
import org.apache.hadoop.io.SequenceFile;
import org.apache.hadoop.io.Writable;
import org.apache.hadoop.io.WritableComparable;
import org.apache.mahout.clustering.canopy.CanopyDriver;
import org.apache.mahout.clustering.kmeans.KMeansDriver;
import org.apache.mahout.common.distance.EuclideanDistanceMeasure;
import org.apache.mahout.common.distance.ManhattanDistanceMeasure;

public class Test_KMeansClustering {

	/**
	 * @param args
	 * @throws IOException 
	 * @throws IllegalAccessException 
	 * @throws InstantiationException 
	 */
	public static void main(String[] args) throws IOException, InstantiationException, IllegalAccessException {
		// TODO Auto-generated method stub
		String root = "C:\\Users\\HE GAOJIE\\Desktop\\test";
		String vectorsSeqFile = root + "\\vectors";
		String centroidsSeqFile = root + "\\centroids";
		String output = root + "\\result";
		
		// for out link
//		double t1 = 320;
//		double t2 = 300;
		
		// for html
		double t1 = 28;
		double t2 = 24;
		
		// Canopy clustering
		CanopyDriver.runJob(vectorsSeqFile, centroidsSeqFile, ManhattanDistanceMeasure.class.getName(), t1, t2);
		System.out.println("1 Done!");
		Writer writer = new FileWriter(centroidsSeqFile + "\\log.txt");
		
		Configuration conf = new Configuration();
		FileSystem fs = FileSystem.get(conf);
		SequenceFile.Reader reader = new SequenceFile.Reader(fs, new Path(centroidsSeqFile + "\\part-00000"), conf);
		
		WritableComparable key = (WritableComparable) reader.getKeyClass().newInstance();
		Writable value = (Writable) reader.getValueClass().newInstance();
		int k = 0;
		while (reader.next(key, value))
		{
			k++;
			writer.write(key.toString() + " belongs to cluster " + value.toString());
			writer.write("\n");
			System.out.println(key.toString() + " belongs to cluster " + value.toString());
		}
		System.out.println("The K number of clusters = " + k);
		reader.close();
		writer.flush();
		writer.close();
		
		//K-means clustering
//		KMeansDriver.runJob(vectorsSeqFile, centroidsSeqFile, output, EuclideanDistanceMeasure.class.getName(), 0.001, 20, 1);
//		System.out.println("2 Done!");
//		
//		Configuration conf1 = new Configuration();
//		FileSystem fs1 = FileSystem.get(conf1);
//		SequenceFile.Reader reader1 = new SequenceFile.Reader(fs1, new Path(output + "\\points\\part-00000"), conf1);
//		WritableComparable key1 = (WritableComparable) reader1.getKeyClass().newInstance();
//		Writable value1 = (Writable) reader1.getValueClass().newInstance();
//		
//		Writer writer1 = new FileWriter(output + "\\log.txt");
//		Writer writer2 = new FileWriter(output + "\\KMeansResult.txt");
//		
//		HashMap<Integer, ArrayList<String>> map = new HashMap<Integer, ArrayList<String>>();
//		while (reader1.next(key1, value1))
//		{
//			System.out.println(key1.toString() + " belongs to cluster " + value1.toString());
//			writer1.write(key1.toString() + " belongs to cluster " + value1.toString());
//			writer1.write("\n");
//			
//			if (!map.containsKey(new Integer(value1.toString())))
//			{
//				ArrayList<String> list = new ArrayList<String>();
//				list.add(key1.toString());
//				map.put(new Integer(value1.toString()), list);
//			}
//			else
//			{
//				ArrayList<String> list = map.get(new Integer(value1.toString()));
//				list.add(key1.toString());
//				map.put(new Integer(value1.toString()), list);
//			}
//		}
//		
//		reader1.close();
//		writer1.flush();
//		writer1.close();
//		
//		
//		//map.
//		Set<Integer> keyset = map.keySet();
//		Iterator<Integer> iterator = keyset.iterator();
//		while (iterator.hasNext())
//		{
//			Integer c = iterator.next();
//			String cluster = "C" + c.toString();	
//			ArrayList<String> list = map.get(c);
//			writer2.write(cluster + " {" + list.size() + "} : " + "[");
//			for (int i = 0; i < list.size(); i++)
//			{
//				writer2.write(list.get(i) + ", ");
//			}
//			writer2.write("]");
//			writer2.write("\n");
//		}
//		writer2.flush();
//		writer2.close();
		
		
		
		
		
	}

}
